﻿using System.Data.Objects;
using Palmmedia.Common.Ioc;
using Palmmedia.MvcSampleApplication.Core.Domain.Repository;

namespace Palmmedia.MvcSampleApplication.Core.Database
{
    /// <summary>
    /// Implementation of <see cref="IUnitOfWorkFactory"/> based on Entity Framework 4.0.
    /// </summary>
    public class EFUnitOfWorkFactory : IUnitOfWorkFactory
    {
        /// <summary>
        /// Creates a new instance of <see cref="EFUnitOfWork"/>.
        /// </summary>
        /// <returns>
        /// The created instance of <see cref="EFUnitOfWork"/>.
        /// </returns>
        public IUnitOfWork Create()
        {
            return new EFUnitOfWork(IocHelper.Resolve<ObjectContext>());
        }
    }
}
