//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Palmmedia.MvcSampleApplication.Core.Domain.Entities
{
        /// <summary>
        /// Helper class that captures most of the change tracking work that needs to be done
        /// for self tracking entities.
        /// </summary>
        [DataContract(IsReference = true)]
        public class ObjectChangeTracker
        {
            #region  Fields
            private bool _isDeserializing;
            private ObjectState _objectState;
            private bool _changeTrackingEnabled;
            private OriginalValueForReferenceProperties _originalValuesForReferenceProperties;
            private AddedObjectsToCollectionProperties _addedObjectsToCollections = new AddedObjectsToCollectionProperties();
            private DeletedObjectsFromCollectionProperties _removedObjectsFromCollections = new DeletedObjectsFromCollectionProperties();
            #endregion
    
            #region Constructor
            public ObjectChangeTracker()
            {
                _changeTrackingEnabled = false;
                _objectState = ObjectState.Unchanged;
            }
            #endregion
    
            [DataMember]
            public ObjectState State
            {
                get { return _objectState; }
                set
                {
                    if (_isDeserializing || _changeTrackingEnabled)
                    {
                        if (value == ObjectState.Modified)
                        {
                            if ((_objectState != ObjectState.Deleted) && (_objectState != ObjectState.Added))
                            {
                                _objectState = value;
                            }
                        }
                        else if (value == ObjectState.Added)
                        {
                            if (_objectState == ObjectState.Deleted)
                            {
                                throw new InvalidOperationException("Adding a deleted object is not allowed");
                            }
                            _objectState = value;
                        }
                        else
                        {
                            _objectState = value;
                        }
                    }
                }
            }
    
            public bool ChangeTrackingEnabled
            {
                get { return _changeTrackingEnabled; }
                set { _changeTrackingEnabled = value; }
            }
    
            /// <summary>
            /// Returns the removed objects to collection valued properties that were changed.
            /// </summary>
            [DataMember]
            public DeletedObjectsFromCollectionProperties RemovedObjectsFromCollectionProperties
            {
                get
                {
                    if (_removedObjectsFromCollections == null)
                    {
                        _removedObjectsFromCollections = new DeletedObjectsFromCollectionProperties();
                    }
                    return _removedObjectsFromCollections;
                }
            }
    
            /// <summary>
            /// Returns the original values for all Ref properties that were changed.
            /// </summary>
            [DataMember]
            public OriginalValueForReferenceProperties OriginalValuesForReferenceProperties
            {
                get
                {
                    if (_originalValuesForReferenceProperties == null)
                    {
                        _originalValuesForReferenceProperties = new OriginalValueForReferenceProperties();
                    }
                    return _originalValuesForReferenceProperties;
                }
            }
    
            /// <summary>
            /// Returns the added objects to collection valued properties that were changed.
            /// </summary>
            [DataMember]
            public AddedObjectsToCollectionProperties AddedObjectsToCollectionProperties
            {
                get
                {
                    if (_addedObjectsToCollections == null)
                    {
                        _addedObjectsToCollections = new AddedObjectsToCollectionProperties();
                    }
                    return _addedObjectsToCollections;
                }
            }
    
            #region MethodsForChangeTrackingOnClient
            [OnDeserializing()]
            internal void OnDeserializingMethod(StreamingContext context)
            {
                _isDeserializing = true;
            }
    
            [OnDeserialized()]
            internal void OnDeserializedMethod(StreamingContext context)
            {
                _isDeserializing = false;
            }
    
            /// <summary>
            /// Captures the original value for Reference. Called after a Reference property changes.
            /// </summary>
            /// <param name="propertyName"></param>
            /// <param name="value"></param>
            internal void RecordOriginalValueForReference(string propertyName, object value)
            {
                if (_changeTrackingEnabled)
                {
    
                    if (!this.OriginalValuesForReferenceProperties.ContainsKey(propertyName))
                    {
                        OriginalValuesForReferenceProperties[propertyName] = value;
                    }
                }
            }
    
            /// <summary>
            /// Records an addition to collection valued properties on SelfTracking Entities.
            /// </summary>
            /// <param name="propertyName"></param>
            /// <param name="value"></param>
            internal void RecordAdditionToCollectionProperties(string propertyName, object value)
            {
                if (_changeTrackingEnabled)
                {
                    // Add the entity back after deleting it, we should do nothing here then
                    if (this.RemovedObjectsFromCollectionProperties.ContainsKey(propertyName)
                        && this.RemovedObjectsFromCollectionProperties[propertyName].Contains(value))
                    {
                        this.RemovedObjectsFromCollectionProperties[propertyName].Remove(value);
                        if (this.RemovedObjectsFromCollectionProperties[propertyName].Count == 0)
                        {
                            this.RemovedObjectsFromCollectionProperties.Remove(propertyName);
                        }
                        return;
                    }
    
                    if (!this.AddedObjectsToCollectionProperties.ContainsKey(propertyName))
                    {
                        AddedObjectsToCollectionProperties[propertyName] = new ListOfObjects();
                        AddedObjectsToCollectionProperties[propertyName].Add(value);
                    }
                    else
                    {
                        AddedObjectsToCollectionProperties[propertyName].Add(value);
                    }
                }
            }
    
            /// <summary>
            /// Records a removal to collection valued properties on SelfTracking Entities.
            /// </summary>
            /// <param name="propertyName"></param>
            /// <param name="value"></param>
            internal void RecordRemovalFromCollectionProperties(string propertyName, object value)
            {
                if (_changeTrackingEnabled)
                {
                    // Delete the entity back after adding it, we should do nothing here then
                    if (this.AddedObjectsToCollectionProperties.ContainsKey(propertyName)
                        && this.AddedObjectsToCollectionProperties[propertyName].Contains(value))
                    {
                        this.AddedObjectsToCollectionProperties[propertyName].Remove(value);
                        if (this.AddedObjectsToCollectionProperties[propertyName].Count == 0)
                        {
                            this.AddedObjectsToCollectionProperties.Remove(propertyName);
                        }
                        return;
                    }
    
                    if (!this.RemovedObjectsFromCollectionProperties.ContainsKey(propertyName))
                    {
                        RemovedObjectsFromCollectionProperties[propertyName] = new ListOfObjects();
                        RemovedObjectsFromCollectionProperties[propertyName].Add(value);
                    }
                    else
                    {
                        if (!RemovedObjectsFromCollectionProperties[propertyName].Contains(value))
                        {
                            RemovedObjectsFromCollectionProperties[propertyName].Add(value);
                        }
                    }
                }
            }
            #endregion
        }
    
        #region EnumForObjectState
        public enum ObjectState
        {
            Unchanged,
            Added,
            Modified,
            Deleted
        }
        #endregion
    
        [CollectionDataContract (Name = "AddedObjectsToCollectionProperties",
            ItemName = "AddedObjectsForProperty", KeyName = "CollectionPropertyName", ValueName = "AddedObjects")]
        public class AddedObjectsToCollectionProperties : Dictionary<string, ListOfObjects> { }
    
        [CollectionDataContract (Name = "DeletedObjectsFromCollectionProperties",
            ItemName = "DeletedObjectsForProperty", KeyName = "CollectionPropertyName",ValueName = "DeletedObjects")]
        public class DeletedObjectsFromCollectionProperties : Dictionary<string, ListOfObjects> { }
    
        [CollectionDataContract(Name = "OriginalValueForReferenceProperties",
        ItemName = "OriginalValueForProperty", KeyName = "ReferencePropertyName", ValueName = "OriginalValue")]
        public class OriginalValueForReferenceProperties : Dictionary<string, Object> { }
    
        [CollectionDataContract(ItemName = "ObjectValue")]
        public class ListOfObjects : List<object> { }
}
