﻿using System;
using System.ServiceModel.Configuration;

namespace Palmmedia.MvcSampleApplication.Service.WcfFacade.I18n
{
    /// <summary>
    /// <see cref="BehaviorExtensionElement"/> to add <see cref="I18nBehavior"/> to a service or endpoint.
    /// </summary>
    public class I18nBehaviorExtensionElement : BehaviorExtensionElement
    {
        /// <summary>
        /// Gets the type of behavior.
        /// </summary>
        /// <value></value>
        /// <returns>A <see cref="T:System.Type"/>.</returns>
        public override Type BehaviorType
        {
            get
            {
                return typeof(I18nBehavior);
            }
        }

        /// <summary>
        /// Creates a behavior extension based on the current configuration settings.
        /// </summary>
        /// <returns>The behavior extension.</returns>
        protected override object CreateBehavior()
        {
            return new I18nBehavior();
        }
    }
}
