﻿using System.Web.Mvc;
using System.Web.Routing;
using log4net;
using Palmmedia.Common.Net.Mvc.Localization;
using Palmmedia.MvcSampleApplication.UI.AspMvc.Controllers;

namespace MvcApplication1
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        /// <summary>
        /// Logger instance.
        /// </summary>
        private static readonly ILog logger = LogManager.GetLogger(typeof(MvcApplication));

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            routes.IgnoreRoute("{*favicon}", new { favicon = @"(.*/)?favicon.ico(/.*)?" });

            routes.MapRoute(
                "Default",
                "{controller}/{action}/{id}",
                new { controller = "Home", action = "Index", id = string.Empty });
        }

        protected void Application_Start()
        {
            // Init logger
            log4net.Config.XmlConfigurator.Configure();

            ControllerBuilder.Current.SetControllerFactory(new IocControllerFactory());

            ViewEngines.Engines.Clear();
            ViewEngines.Engines.Add(new LocalizationWebFormViewEngine());

            AreaRegistration.RegisterAllAreas();

            RegisterRoutes(RouteTable.Routes);

            logger.Debug("Application started.");
        }
    }
}